import { buildRequestParams } from "./../helpers/index.mjs";
import { useRuntimeConfig } from "#imports";
function getEndpoint(operation, operationName) {
  const config = useRuntimeConfig();
  return `${config?.public?.["nuxt-graphql-middleware"]?.serverApiPrefix}/${operation}/${operationName}`;
}
const state = {
  fetchOptions: {}
};
export const useGraphqlState = () => {
  return state;
};
export function useGraphqlQuery(...args) {
  const name = args[0];
  if (typeof name !== "string") {
    return Promise.reject(new Error("Invalid query name"));
  }
  const state2 = useGraphqlState();
  return $fetch(getEndpoint("query", name), {
    params: buildRequestParams(args[1]),
    ...state2.fetchOptions
  });
}
export function useGraphqlMutation(...args) {
  const state2 = useGraphqlState();
  const name = args[0];
  const body = args[1] || {};
  if (typeof name !== "string") {
    return Promise.reject(new Error("Invalid mutation name"));
  }
  return $fetch(getEndpoint("mutation", name), {
    method: "post",
    body,
    ...state2.fetchOptions
  });
}
